Subject: Re: linux-next: manual merge of the akpm tree with the nfs tree

From: "Myklebust, Trond" <[email-masked]>
Date: Tue, 31 Jul 2012 14:37:24 +0000

On Tue, 2012-07-31 at 11:33 +0100, Mel Gorman wrote:
> On Tue, Jul 31, 2012 at 02:24:41PM +1000, Stephen Rothwell wrote:
> > Hi Andrew,
> > 
> > Today's linux-next merge of the akpm tree got a conflict in
> > net/sunrpc/xprtsock.c between commit 5cf02d09b50b ("nfs: skip commit in
> > releasepage if we're freeing memory for fs-related reasons") from the nfs
> > tree and commit "nfs: enable swap on NFS" from the akpm tree.
> > 
> > Just context changes?  I fixed it up (I think - see below) and can carry
> > the fix as necessary.
> 
> Functionally it looks fine. As you say, it all looks like context
> changes. Arguably code like this
> 
> current->flags &= ~PF_FSTRANS
> 
> could use tsk_restore_flags instead() even though it should never be
> necessary as PF_FSTRANS would not be set on function entry. However,
> it would set up a depedency between the patch sets that is undesirable.
> If both sets get merged then it might make sense as a cleanup to use
> tsk_restore_flags() but not until then.
> 
> Thanks Stephen.
> 

Do we really need to set both PF_FSTRANS and PF_MEMALLOC here? The
reason why I merged the PF_FSTRANS patch is that we have the deadlock
problem when allocating a new socket even before we add swap-over-nfs.
Adding PF_FSTRANS to disallow entry into the NFS layer by the memory
allocator fixes that issue.
What value does PF_MEMALLOC add? Is that in order to prevent recursion
into other areas of the swap code (say, if you mix swap-over-nfs with
ordinary swap-to-disk)?

Cheers
  Trond
-- 
Trond Myklebust
Linux NFS client maintainer

NetApp
[email-masked]
www.netapp.com